Index: branches/1.3/gui/scripts/vtkstreamlinesviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkstreamlinesviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/vtkstreamlinesviewer.tcl	(revision 4848)
@@ -1,5 +1,5 @@
 # -*- mode: tcl; indent-tabs-mode: nil -*- 
 # ----------------------------------------------------------------------
-#  COMPONENT: vtkstreamlinesviewer - Vtk streamlines object viewer
+#  COMPONENT: vtkviewer - Vtk drawing object viewer
 #
 #  It connects to the Vtk server running on a rendering farm,
@@ -7,5 +7,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2014  HUBzero Foundation, LLC
+#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
 #
 #  See the file "license.terms" for information on usage and
@@ -62,6 +62,22 @@
     public method scale {args}
 
+    protected method Connect {}
+    protected method CurrentDatasets {args}
+    protected method Disconnect {}
+    protected method DoResize {}
+    protected method DoReseed {}
+    protected method DoRotate {}
+    protected method AdjustSetting {what {value ""}}
+    protected method InitSettings { args  }
+    protected method Pan {option x y}
+    protected method Pick {x y}
+    protected method Rebuild {}
+    protected method ReceiveDataset { args }
+    protected method ReceiveImage { args }
+    protected method ReceiveLegend { colormap title vmin vmax size }
+    protected method Rotate {option x y}
+    protected method Zoom {option}
+
     # The following methods are only used by this class.
-    private method AdjustSetting {what {value ""}}
     private method BuildAxisTab {}
     private method BuildCameraTab {}
@@ -73,10 +89,4 @@
     private method DrawLegend {}
     private method Combo { option }
-    private method Connect {}
-    private method CurrentDatasets {args}
-    private method Disconnect {}
-    private method DoResize {}
-    private method DoReseed {}
-    private method DoRotate {}
     private method EnterLegend { x y } 
     private method EventuallyResize { w h } 
@@ -86,20 +96,9 @@
     private method GetImage { args } 
     private method GetVtkData { args } 
-    private method InitSettings { args  }
     private method IsValidObject { dataobj } 
     private method LeaveLegend {}
     private method MotionLegend { x y } 
-    private method Pan {option x y}
     private method PanCamera {}
-    private method Pick {x y}
-    private method QuaternionToView { q } { 
-        foreach { _view(-qw) _view(-qx) _view(-qy) _view(-qz) } $q break
-    }
-    private method Rebuild {}
-    private method ReceiveDataset { args }
-    private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
     private method RequestLegend {}
-    private method Rotate {option x y}
     private method SetColormap { dataobj comp }
     private method ChangeColormap { dataobj comp color }
@@ -108,8 +107,4 @@
     private method Slice {option args} 
     private method SetOrientation { side }
-    private method ViewToQuaternion {} { 
-        return [list $_view(-qw) $_view(-qx) $_view(-qy) $_view(-qz)]
-    }
-    private method Zoom {option}
 
     private variable _arcball ""
@@ -194,15 +189,15 @@
     $_dispatcher register !xcutplane
     $_dispatcher dispatch $this !xcutplane \
-        "[itcl::code $this AdjustSetting -cutplanexposition]; list"
+        "[itcl::code $this AdjustSetting cutplaneXPosition]; list"
 
     # Y-Cutplane event
     $_dispatcher register !ycutplane
     $_dispatcher dispatch $this !ycutplane \
-        "[itcl::code $this AdjustSetting -cutplaneyposition]; list"
+        "[itcl::code $this AdjustSetting cutplaneYPosition]; list"
 
     # Z-Cutplane event
     $_dispatcher register !zcutplane
     $_dispatcher dispatch $this !zcutplane \
-        "[itcl::code $this AdjustSetting -cutplanezposition]; list"
+        "[itcl::code $this AdjustSetting cutplaneZPosition]; list"
 
     #
@@ -215,48 +210,47 @@
     # Initialize the view to some default parameters.
     array set _view {
-        -ortho           0
-        -qw              0.853553
-        -qx              -0.353553
-        -qy              0.353553
-        -qz              0.146447
-        -xpan            0
-        -ypan            0
-        -zoom            1.0
+        qw              0.853553
+        qx              -0.353553
+        qy              0.353553
+        qz              0.146447
+        zoom            1.0 
+        xpan            0
+        ypan            0
+        ortho           0
     }
     set _arcball [blt::arcball create 100 100]
-    $_arcball quaternion [ViewToQuaternion]
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    $_arcball quaternion $q
 
     array set _settings [subst {
-        -axesvisible                1
-        -axislabelsvisible          1
-        -axisminorticks             1
-        -axismode                   "static"
-        -cutplaneedges              0
-        -cutplanelighting           1
-        -cutplaneopacity            100
-        -cutplanevisible            0
-        -cutplanewireframe          0
-        -cutplanexposition          50
-        -cutplanexvisible           1
-        -cutplaneyposition          50
-        -cutplaneyvisible           1
-        -cutplanezposition          50
-        -cutplanezvisible           1
-        -legendvisible              1
-        -streamlineslighting        1
-        -streamlinesmode            lines
-        -streamlinesnumseeds        200
-        -streamlinesopacity         100
-        -streamlinesscale           1
-        -streamlinesseedsvisible    0
-        -streamlinesvisible         1
-        -volumeedges                0
-        -volumelighting             1
-        -volumeopacity              40
-        -volumevisible              1
-        -volumewireframe            0
-        -xgrid                      0
-        -ygrid                      0
-        -zgrid                      0
+        axesVisible		1
+        axisLabelsVisible	1
+        axisXGrid		0
+        axisYGrid		0
+        axisZGrid		0
+        cutplaneEdges		0
+        cutplaneLighting	1
+        cutplaneOpacity		100
+        cutplaneVisible		0
+        cutplaneWireframe	0
+        cutplaneXPosition	50
+        cutplaneXVisible	1
+        cutplaneYPosition	50
+        cutplaneYVisible	1
+        cutplaneZPosition	50
+        cutplaneZVisible	1
+        legendVisible           1
+        streamlinesLighting     1
+        streamlinesMode		lines
+        streamlinesNumSeeds	200
+        streamlinesOpacity	100
+        streamlinesScale        1
+        streamlinesSeedsVisible 0
+        streamlinesVisible	1
+        volumeEdges		0
+        volumeLighting		1
+        volumeOpacity		40
+        volumeVisible		1
+        volumeWireframe		0
     }]
 
@@ -337,6 +331,6 @@
             -onimage [Rappture::icon volume-on] \
             -offimage [Rappture::icon volume-off] \
-            -variable [itcl::scope _settings(-volumevisible)] \
-            -command [itcl::code $this AdjustSetting -volumevisible] 
+            -variable [itcl::scope _settings(volumeVisible)] \
+            -command [itcl::code $this AdjustSetting volumeVisible] 
     }
     $itk_component(volume) select
@@ -349,6 +343,6 @@
             -onimage [Rappture::icon streamlines-on] \
             -offimage [Rappture::icon streamlines-off] \
-            -variable [itcl::scope _settings(-streamlinesvisible)] \
-            -command [itcl::code $this AdjustSetting -streamlinesvisible] \
+            -variable [itcl::scope _settings(streamlinesVisible)] \
+            -command [itcl::code $this AdjustSetting streamlinesVisible] \
     }
     $itk_component(streamlines) select
@@ -361,6 +355,6 @@
             -onimage [Rappture::icon cutbutton] \
             -offimage [Rappture::icon cutbutton] \
-            -variable [itcl::scope _settings(-cutplanevisible)] \
-            -command [itcl::code $this AdjustSetting -cutplanevisible] 
+            -variable [itcl::scope _settings(cutplaneVisible)] \
+            -command [itcl::code $this AdjustSetting cutplaneVisible] 
     }
     Rappture::Tooltip::for $itk_component(cutplane) \
@@ -405,5 +399,11 @@
     bind $itk_component(view) <ButtonRelease-1> \
         [itcl::code $this Rotate release %x %y]
-
+    bind $itk_component(view) <Configure> \
+        [itcl::code $this EventuallyResize %w %h]
+
+    if 0 {
+    bind $itk_component(view) <Configure> \
+        [itcl::code $this EventuallyResize %w %h]
+    }
     # Bindings for panning via mouse
     bind $itk_component(view) <ButtonPress-2> \
@@ -453,4 +453,5 @@
     eval itk_initialize $args
     Connect
+    update
 }
 
@@ -480,5 +481,6 @@
 
 itcl::body Rappture::VtkStreamlinesViewer::DoRotate {} {
-    SendCmd "camera orient [ViewToQuaternion]" 
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    SendCmd "camera orient $q" 
     set _rotatePending 0
 }
@@ -514,5 +516,5 @@
 
 itcl::body Rappture::VtkStreamlinesViewer::EventuallyRotate { q } {
-    QuaternionToView $q
+    foreach { _view(qw) _view(qx) _view(qy) _view(qz) } $q break
     if { !$_rotatePending } {
         set _rotatePending 1
@@ -786,5 +788,5 @@
         if { $_reportClientInfo }  {
             # Tell the server the viewer, hub, user and session.
-            # Do this immediately on connect before buffering any commands
+            # Do this immediately on connect before buffing any commands
             global env
 
@@ -876,7 +878,6 @@
     if { $info(-type) == "image" } {
         if 0 {
-            set f [open "last.ppm" "w"]
-            fconfigure $f -encoding binary
-            puts -nonewline $f $bytes
+            set f [open "last.ppm" "w"] 
+            puts $f $bytes
             close $f
         }
@@ -969,6 +970,6 @@
 	$_arcball resize $w $h
 	DoResize
-	InitSettings -xgrid -ygrid -zgrid -axismode \
-	    -axesvisible -axislabelsvisible -axisminorticks
+	InitSettings axisXGrid axisYGrid axisZGrid axis-mode \
+	    axesVisible axisLabelsVisible 
         # This "imgflush" is to force an image returned before vtkvis starts
         # reading a (big) dataset.  This will display an empty plot with axes
@@ -992,5 +993,5 @@
                     set f [open /tmp/vtkstreamlines.vtk "w"]
                     fconfigure $f -translation binary -encoding binary
-                    puts -nonewline $f $bytes
+                    puts $f $bytes
                     close $f
 		}
@@ -1026,9 +1027,9 @@
             set label [$_first hints ${axis}label]
             if { $label != "" } {
-                SendCmd [list axis name $axis $label]
+                SendCmd "axis name $axis $label"
             }
             set units [$_first hints ${axis}units]
             if { $units != "" } {
-                SendCmd [list axis units $axis $units]
+                SendCmd "axis units $axis $units"
             }
         }
@@ -1063,17 +1064,18 @@
 
     if { $_reset } {
-        InitSettings -streamlinesseedsvisible -streamlinesopacity \
-            -streamlinesvisible -streamlinescolormap \
-            -streamlineslighting \
-            -streamlinescolormap -field \
-            -volumevisible -volumeedges -volumelighting -volumeopacity \
-            -volumewireframe \
-	    -cutplanevisible \
-	    -cutplanexposition -cutplaneyposition -cutplanezposition \
-	    -cutplanexvisible -cutplaneyvisible -cutplanezvisible
+        InitSettings streamlinesSeedsVisible streamlinesOpacity \
+            streamlinesVisible streamlinesColormap \
+            streamlinesLighting \
+            streamlinesColormap field \
+            volumeVisible volumeEdges volumeLighting volumeOpacity \
+            volumeWireframe \
+	    cutplaneVisible \
+	    cutplaneXPosition cutplaneYPosition cutplaneZPosition \
+	    cutplaneXVisible cutplaneYVisible cutplaneZVisible
 
 	# Reset the camera and other view parameters
-	$_arcball quaternion [ViewToQuaternion]
-	if {$_view(-ortho)} {
+	set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+	$_arcball quaternion $q
+	if {$_view(ortho)} {
 	    SendCmd "camera mode ortho"
 	} else {
@@ -1149,20 +1151,20 @@
     switch -- $option {
         "in" {
-            set _view(-zoom) [expr {$_view(-zoom)*1.25}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*1.25}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "out" {
-            set _view(-zoom) [expr {$_view(-zoom)*0.8}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*0.8}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "reset" {
             array set _view {
-                -qw      0.853553
-                -qx      -0.353553
-                -qy      0.353553
-                -qz      0.146447
-                -xpan    0
-                -ypan    0
-                -zoom    1.0
+                qw      0.853553
+                qx      -0.353553
+                qy      0.353553
+                qz      0.146447
+                zoom    1.0
+                xpan    0
+                ypan    0
             }
             if { $_first != "" } {
@@ -1172,5 +1174,6 @@
                 }
             }
-            $_arcball quaternion [ViewToQuaternion]
+            set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+            $_arcball quaternion $q
             DoRotate
             SendCmd "camera reset"
@@ -1180,8 +1183,9 @@
 
 itcl::body Rappture::VtkStreamlinesViewer::PanCamera {} {
-    set x $_view(-xpan)
-    set y $_view(-ypan)
+    set x $_view(xpan)
+    set y $_view(ypan)
     SendCmd "camera pan $x $y"
 }
+
 
 # ----------------------------------------------------------------------
@@ -1258,6 +1262,6 @@
             set x [expr $x / double($w)]
             set y [expr $y / double($h)]
-            set _view(-xpan) [expr $_view(-xpan) + $x]
-            set _view(-ypan) [expr $_view(-ypan) + $y]
+            set _view(xpan) [expr $_view(xpan) + $x]
+            set _view(ypan) [expr $_view(ypan) + $y]
             PanCamera
             return
@@ -1281,6 +1285,6 @@
             set _click(x) $x
             set _click(y) $y
-            set _view(-xpan) [expr $_view(-xpan) - $dx]
-            set _view(-ypan) [expr $_view(-ypan) - $dy]
+            set _view(xpan) [expr $_view(xpan) - $dx]
+            set _view(ypan) [expr $_view(ypan) - $dy]
             PanCamera
         }
@@ -1304,7 +1308,7 @@
 itcl::body Rappture::VtkStreamlinesViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
+        if { [info exists _settings($_first-$spec)] } {
             # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
+            set _settings($spec) $_settings($_first-$spec)
         }
         AdjustSetting $spec
@@ -1324,17 +1328,46 @@
     }
     switch -- $what {
-        "-axesvisible" {
+        "volumeOpacity" {
+            set val $_settings(volumeOpacity)
+            set sval [expr { 0.01 * double($val) }]
+            SendCmd "polydata opacity $sval"
+        }
+        "volumeWireframe" {
+            set bool $_settings(volumeWireframe)
+            SendCmd "polydata wireframe $bool"
+        }
+        "volumeVisible" {
+            set bool $_settings(volumeVisible)
+            SendCmd "polydata visible $bool"
+            if { $bool } {
+                Rappture::Tooltip::for $itk_component(volume) \
+                    "Hide the volume"
+            } else {
+                Rappture::Tooltip::for $itk_component(volume) \
+                    "Show the volume"
+            }
+        }
+        "volumeLighting" {
+            set bool $_settings(volumeLighting)
+            SendCmd "polydata lighting $bool"
+        }
+        "volumeEdges" {
+            set bool $_settings(volumeEdges)
+            SendCmd "polydata edges $bool"
+        }
+        "axesVisible" {
+            set bool $_settings(axesVisible)
+            SendCmd "axis visible all $bool"
+        }
+        "axisLabelsVisible" {
+            set bool $_settings(axisLabelsVisible)
+            SendCmd "axis labels all $bool"
+        }
+        "axisXGrid" - "axisYGrid" - "axisZGrid" {
+            set axis [string tolower [string range $what 4 4]]
             set bool $_settings($what)
-            SendCmd "axis visible all $bool"
-        }
-        "-axislabelsvisible" {
-            set bool $_settings($what)
-            SendCmd "axis labels all $bool"
-        }
-        "-axisminorticks" {
-            set bool $_settings($what)
-            SendCmd "axis minticks all $bool"
-        }
-        "-axismode" {
+            SendCmd "axis grid $axis $bool"
+        }
+        "axis-mode" {
             set mode [$itk_component(axismode) value]
             set mode [$itk_component(axismode) translate $mode]
@@ -1342,27 +1375,27 @@
             SendCmd "axis flymode $mode"
         }
-        "-cutplaneedges" {
+        "cutplaneEdges" {
             set bool $_settings($what)
             SendCmd "cutplane edges $bool"
         }
-        "-cutplanevisible" {
+        "cutplaneVisible" {
             set bool $_settings($what)
             SendCmd "cutplane visible $bool"
         }
-        "-cutplanewireframe" {
+        "cutplaneWireframe" {
             set bool $_settings($what)
             SendCmd "cutplane wireframe $bool"
         }
-        "-cutplanelighting" {
+        "cutplaneLighting" {
             set bool $_settings($what)
             SendCmd "cutplane lighting $bool"
         }
-        "-cutplaneopacity" {
+        "cutplaneOpacity" {
             set val $_settings($what)
             set sval [expr { 0.01 * double($val) }]
             SendCmd "cutplane opacity $sval"
         }
-        "-cutplanexvisible" - "-cutplaneyvisible" - "-cutplanezvisible" {
-            set axis [string range $what 9 9]
+        "cutplaneXVisible" - "cutplaneYVisible" - "cutplaneZVisible" {
+            set axis [string tolower [string range $what 8 8]]
             set bool $_settings($what)
             if { $bool } {
@@ -1375,46 +1408,19 @@
             SendCmd "cutplane axis $axis $bool"
         }
-        "-cutplanexposition" - "-cutplaneyposition" - "-cutplanezposition" {
-            set axis [string range $what 9 9]
+        "cutplaneXPosition" - "cutplaneYPosition" - "cutplaneZPosition" {
+            set axis [string tolower [string range $what 8 8]]
             set pos [expr $_settings($what) * 0.01]
             SendCmd "cutplane slice ${axis} ${pos}"
             set _cutplanePending 0
         }
-        "-field" {
-            set label [$itk_component(field) value]
-            set fname [$itk_component(field) translate $label]
-            set _settings($what) $fname
-            if { [info exists _fields($fname)] } {
-                foreach { label units components } $_fields($fname) break
-                if { $components > 1 } {
-                    set _colorMode vmag
-                } else {
-                    set _colorMode scalar
-                }
-                set _curFldName $fname
-                set _curFldLabel $label
-            } else {
-                puts stderr "unknown field \"$fname\""
-                return
-            }
-            # Get the new limits because the field changed.
-            if { ![info exists _limits($_curFldName)] } {
-                SendCmd "dataset maprange all"
-            } else {
-                SendCmd "dataset maprange explicit $_limits($_curFldName) $_curFldName"
-            }
-            SendCmd "streamlines colormode $_colorMode $_curFldName"
-            SendCmd "cutplane colormode $_colorMode $_curFldName"
-            DrawLegend
-        }
-        "-streamlinesseedsvisible" {
+        "streamlinesSeedsVisible" {
             set bool $_settings($what)
             SendCmd "streamlines seed visible $bool"
         }
-        "-streamlinesnumseeds" {
+        "streamlinesNumSeeds" {
             set density $_settings($what)
             EventuallyReseed $density
         }
-        "-streamlinesvisible" {
+        "streamlinesVisible" {
             set bool $_settings($what)
             SendCmd "streamlines visible $bool"
@@ -1427,7 +1433,7 @@
             }
         }
-        "-streamlinesmode" {
+        "streamlinesMode" {
             set mode [$itk_component(streammode) value]
-            set _settings($what) $mode
+            set _settings(streamlinesMode) $mode
             switch -- $mode {
                 "lines" {
@@ -1442,7 +1448,7 @@
             }
         }
-        "-streamlinescolormap" {
+        "streamlinesColormap" {
             set colormap [$itk_component(colormap) value]
-            set _settings($what) $colormap
+            set _settings(streamlinesColormap) $colormap
             foreach dataset [CurrentDatasets -visible $_first] {
                 foreach {dataobj comp} [split $dataset -] break
@@ -1451,50 +1457,40 @@
             set _legendPending 1
         }
-        "-streamlinesopacity" {
-            set val $_settings($what)
+        "streamlinesOpacity" {
+            set val $_settings(streamlinesOpacity)
             set sval [expr { 0.01 * double($val) }]
             SendCmd "streamlines opacity $sval"
         }
-        "-streamlinesscale" {
-            set val $_settings($what)
+        "streamlinesScale" {
+            set val $_settings(streamlinesScale)
             set sval [expr { 0.01 * double($val) }]
             SendCmd "streamlines scale $sval $sval $sval"
         }
-        "-streamlineslighting" {
-            set bool $_settings($what)
+        "streamlinesLighting" {
+            set bool $_settings(streamlinesLighting)
             SendCmd "streamlines lighting $bool"
         }
-        "-volumeopacity" {
-            set val $_settings($what)
-            set sval [expr { 0.01 * double($val) }]
-            SendCmd "polydata opacity $sval"
-        }
-        "-volumewireframe" {
-            set bool $_settings($what)
-            SendCmd "polydata wireframe $bool"
-        }
-        "-volumevisible" {
-            set bool $_settings($what)
-            SendCmd "polydata visible $bool"
-            if { $bool } {
-                Rappture::Tooltip::for $itk_component(volume) \
-                    "Hide the volume"
+        "field" {
+            set label [$itk_component(field) value]
+            set fname [$itk_component(field) translate $label]
+            set _settings(field) $fname
+            if { [info exists _fields($fname)] } {
+                foreach { label units components } $_fields($fname) break
+                if { $components > 1 } {
+                    set _colorMode vmag
+                } else {
+                    set _colorMode scalar
+                }
+                set _curFldName $fname
+                set _curFldLabel $label
             } else {
-                Rappture::Tooltip::for $itk_component(volume) \
-                    "Show the volume"
-            }
-        }
-        "-volumelighting" {
-            set bool $_settings($what)
-            SendCmd "polydata lighting $bool"
-        }
-        "-volumeedges" {
-            set bool $_settings($what)
-            SendCmd "polydata edges $bool"
-        }
-        "-xgrid" - "-ygrid" - "-zgrid" {
-            set axis [string range $what 1 1]
-            set bool $_settings($what)
-            SendCmd "axis grid $axis $bool"
+                puts stderr "unknown field \"$fname\""
+                return
+            }
+            # Get the new limits because the field changed.
+            SendCmd "dataset maprange explicit $_limits($_curFldName) $_curFldName"
+            SendCmd "streamlines colormode $_colorMode $_curFldName"
+            SendCmd "cutplane colormode $_colorMode $_curFldName"
+            DrawLegend
         }
         default {
@@ -1514,7 +1510,8 @@
     set font "Arial 8"
     set lineht [font metrics $font -linespace]
+    set c $itk_component(legend)
     set w 12
     set h [expr {$_height - 3 * ($lineht + 2)}]
-    if { $h < 1 } {
+    if { $h < 1} {
         return
     }
@@ -1581,4 +1578,5 @@
 }
 
+
 #
 # BuildColormap --
@@ -1590,8 +1588,8 @@
         set cmap "0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0"
     }
-    if { ![info exists _settings(-volumeopacity)] } {
-        set _settings(-volumeopacity) $style(-opacity)
-    }
-    set max $_settings(-volumeopacity)
+    if { ![info exists _settings(volumeOpacity)] } {
+        set _settings(volumeOpacity) $style(-opacity)
+    }
+    set max $_settings(volumeOpacity)
 
     set wmap "0.0 1.0 1.0 1.0"
@@ -1604,6 +1602,6 @@
 itcl::configbody Rappture::VtkStreamlinesViewer::plotbackground {
     if { [isconnected] } {
-        set rgb [Color2RGB $itk_option(-plotbackground)]
-        SendCmd "screen bgcolor $rgb"
+        foreach {r g b} [Color2RGB $itk_option(-plotbackground)] break
+        SendCmd "screen bgcolor $r $g $b"
     }
 }
@@ -1614,8 +1612,7 @@
 itcl::configbody Rappture::VtkStreamlinesViewer::plotforeground {
     if { [isconnected] } {
-        set rgb [Color2RGB $itk_option(-plotforeground)]
-        SendCmd "axis color all $rgb"
-        SendCmd "outline color $rgb"
-        SendCmd "cutplane color $rgb"
+        foreach {r g b} [Color2RGB $itk_option(-plotforeground)] break
+        #fix this!
+        #SendCmd "color background $r $g $b"
     }
 }
@@ -1633,32 +1630,32 @@
     checkbutton $inner.volume \
         -text "Show Volume" \
-        -variable [itcl::scope _settings(-volumevisible)] \
-        -command [itcl::code $this AdjustSetting -volumevisible] \
+        -variable [itcl::scope _settings(volumeVisible)] \
+        -command [itcl::code $this AdjustSetting volumeVisible] \
         -font "Arial 9"
 
     checkbutton $inner.wireframe \
         -text "Show Wireframe" \
-        -variable [itcl::scope _settings(-volumewireframe)] \
-        -command [itcl::code $this AdjustSetting -volumewireframe] \
+        -variable [itcl::scope _settings(volumeWireframe)] \
+        -command [itcl::code $this AdjustSetting volumeWireframe] \
         -font "Arial 9"
 
     checkbutton $inner.lighting \
         -text "Enable Lighting" \
-        -variable [itcl::scope _settings(-volumelighting)] \
-        -command [itcl::code $this AdjustSetting -volumelighting] \
+        -variable [itcl::scope _settings(volumeLighting)] \
+        -command [itcl::code $this AdjustSetting volumeLighting] \
         -font "Arial 9"
 
     checkbutton $inner.edges \
         -text "Show Edges" \
-        -variable [itcl::scope _settings(-volumeedges)] \
-        -command [itcl::code $this AdjustSetting -volumeedges] \
+        -variable [itcl::scope _settings(volumeEdges)] \
+        -command [itcl::code $this AdjustSetting volumeEdges] \
         -font "Arial 9"
 
     label $inner.opacity_l -text "Opacity" -font "Arial 9"
     ::scale $inner.opacity -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-volumeopacity)] \
+        -variable [itcl::scope _settings(volumeOpacity)] \
         -width 10 \
         -showvalue off \
-        -command [itcl::code $this AdjustSetting -volumeopacity]
+        -command [itcl::code $this AdjustSetting volumeOpacity]
 
     blt::table $inner \
@@ -1673,4 +1670,5 @@
 }
 
+
 itcl::body Rappture::VtkStreamlinesViewer::BuildStreamsTab {} {
 
@@ -1685,18 +1683,18 @@
     checkbutton $inner.streamlines \
         -text "Show Streamlines" \
-        -variable [itcl::scope _settings(-streamlinesvisible)] \
-        -command [itcl::code $this AdjustSetting -streamlinesvisible] \
+        -variable [itcl::scope _settings(streamlinesVisible)] \
+        -command [itcl::code $this AdjustSetting streamlinesVisible] \
         -font "Arial 9"
     
     checkbutton $inner.lighting \
         -text "Enable Lighting" \
-        -variable [itcl::scope _settings(-streamlineslighting)] \
-        -command [itcl::code $this AdjustSetting -streamlineslighting] \
+        -variable [itcl::scope _settings(streamlinesLighting)] \
+        -command [itcl::code $this AdjustSetting streamlinesLighting] \
         -font "Arial 9"
 
     checkbutton $inner.seeds \
         -text "Show Seeds" \
-        -variable [itcl::scope _settings(-streamlinesseedsvisible)] \
-        -command [itcl::code $this AdjustSetting -streamlinesseedsvisible] \
+        -variable [itcl::scope _settings(streamlinesSeedsVisible)] \
+        -command [itcl::code $this AdjustSetting streamlinesSeedsVisible] \
         -font "Arial 9"
 
@@ -1709,27 +1707,27 @@
         "ribbons"   "ribbons" \
         "tubes"     "tubes" 
-    $itk_component(streammode) value $_settings(-streamlinesmode)
-    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting -streamlinesmode]
+    $itk_component(streammode) value $_settings(streamlinesMode)
+    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting streamlinesMode]
 
     label $inner.opacity_l -text "Opacity" -font "Arial 9"
     ::scale $inner.opacity -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-streamlinesopacity)] \
+        -variable [itcl::scope _settings(streamlinesOpacity)] \
         -width 10 \
         -showvalue off \
-        -command [itcl::code $this AdjustSetting -streamlinesopacity]
+        -command [itcl::code $this AdjustSetting streamlinesOpacity]
 
     label $inner.density_l -text "No. Seeds" -font "Arial 9"
     ::scale $inner.density -from 1 -to 1000 -orient horizontal \
-        -variable [itcl::scope _settings(-streamlinesnumseeds)] \
+        -variable [itcl::scope _settings(streamlinesNumSeeds)] \
         -width 10 \
         -showvalue on \
-        -command [itcl::code $this AdjustSetting -streamlinesnumseeds]
+        -command [itcl::code $this AdjustSetting streamlinesNumSeeds]
 
     label $inner.scale_l -text "Scale" -font "Arial 9"
     ::scale $inner.scale -from 1 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-streamlinesscale)] \
+        -variable [itcl::scope _settings(streamlinesScale)] \
         -width 10 \
         -showvalue off \
-        -command [itcl::code $this AdjustSetting -streamlinesscale]
+        -command [itcl::code $this AdjustSetting streamlinesScale]
 
     label $inner.field_l -text "Color by" -font "Arial 9" 
@@ -1738,5 +1736,5 @@
     }
     bind $inner.field <<Value>> \
-        [itcl::code $this AdjustSetting -field]
+        [itcl::code $this AdjustSetting field]
 
     label $inner.colormap_l -text "Colormap" -font "Arial 9" 
